Index: palm/trunk/SCRIPTS/mbuild
===================================================================
--- palm/trunk/SCRIPTS/mbuild	(revision 1816)
+++ palm/trunk/SCRIPTS/mbuild	(revision 1817)
@@ -22,5 +22,5 @@
 # Current revisions:
 # ------------------
-# 
+# Bugfix: Makefile_check removed (parameter file check)
 # 
 # Former revisions:
@@ -427,16 +427,4 @@
     cd  $local_source_path
     printf "\n\n  *** tar of makefile and source files in $local_source_path"  
- 
-    cat Makefile_check|while read line
-    do
-       line=$(echo $line|grep SOURCES)
-       if [[ $line == *"SOURCES"* ]]
-       then
-          line=$(echo $line|sed 's/SOURCES = //g')
-          break
-       fi
-    done
-
-    tar -cf  ${mainprog}_sources_check.tar  Makefile_check  $line
     printf "\n"
  fi
@@ -1481,3 +1469,2 @@
     # FINAL WORK
  rm -f  hosts_found_in_config_file
- rm -f ${local_source_path}/${mainprog}_sources_check.tar
Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1816)
+++ palm/trunk/SOURCE/Makefile	(revision 1817)
@@ -20,5 +20,5 @@
 # Current revisions:
 # ------------------
-# 
+# Renamed land_surface_model to land_surface_model_mod.
 # 
 # Former revisions:
@@ -259,5 +259,5 @@
 	init_grid.f90 init_masks.f90 init_ocean.f90 \
 	init_pegrid.f90 init_pt_anomaly.f90 init_rankine.f90 init_slope.f90 \
-	interaction_droplets_ptq.f90 land_surface_model.f90 \
+	interaction_droplets_ptq.f90 land_surface_model_mod.f90 \
 	local_stop.f90 local_system.f90 local_tremain.f90 \
 	local_tremain_ini.f90 lpm.f90 lpm_advec.f90 lpm_boundary_conds.f90 \
@@ -340,5 +340,5 @@
 advec_w_pw.o: modules.o mod_kinds.o
 advec_w_up.o: modules.o mod_kinds.o
-average_3d_data.o: modules.o cpulog.o mod_kinds.o land_surface_model.o\
+average_3d_data.o: modules.o cpulog.o mod_kinds.o land_surface_model_mod.o\
                    radiation_model.o
 boundary_conds.o: modules.o mod_kinds.o
@@ -350,5 +350,5 @@
 check_for_restart.o: modules.o mod_kinds.o pmc_interface.o
 check_open.o: modules.o mod_kinds.o mod_particle_attributes.o netcdf_interface.o
-check_parameters.o: modules.o mod_kinds.o land_surface_model.o \
+check_parameters.o: modules.o mod_kinds.o land_surface_model_mod.o \
 	netcdf_interface.o plant_canopy_model.o pmc_interface.o radiation_model.o \
 	subsidence.o
@@ -370,7 +370,7 @@
 data_output_tseries.o: modules.o cpulog.o mod_kinds.o netcdf_interface.o
 data_output_2d.o: modules.o cpulog.o mod_kinds.o mod_particle_attributes.o\
-   netcdf_interface.o land_surface_model.o radiation_model.o
+   netcdf_interface.o land_surface_model_mod.o radiation_model.o
 data_output_3d.o: modules.o cpulog.o mod_kinds.o mod_particle_attributes.o\
-   netcdf_interface.o land_surface_model.o
+   netcdf_interface.o land_surface_model_mod.o
 diffusion_e.o: modules.o mod_kinds.o
 diffusion_s.o: modules.o mod_kinds.o
@@ -386,8 +386,8 @@
 exchange_horiz_2d.o: modules.o cpulog.o mod_kinds.o
 fft_xy.o: cuda_fft_interfaces.o modules.o mod_kinds.o singleton.o temperton_fft.o
-flow_statistics.o: modules.o cpulog.o mod_kinds.o land_surface_model.o\
+flow_statistics.o: modules.o cpulog.o mod_kinds.o land_surface_model_mod.o\
    netcdf_interface.o radiation_model.o
 global_min_max.o: modules.o mod_kinds.o
-header.o: modules.o cpulog.o mod_kinds.o netcdf_interface.o land_surface_model.o\
+header.o: modules.o cpulog.o mod_kinds.o netcdf_interface.o land_surface_model_mod.o\
    plant_canopy_model.o pmc_handle_communicator.o pmc_interface.o \
    radiation_model.o spectrum.o subsidence.o 
@@ -395,5 +395,5 @@
 inflow_turbulence.o: modules.o cpulog.o mod_kinds.o
 init_1d_model.o: modules.o mod_kinds.o
-init_3d_model.o: modules.o mod_kinds.o advec_ws.o cpulog.o land_surface_model.o \
+init_3d_model.o: modules.o mod_kinds.o advec_ws.o cpulog.o land_surface_model_mod.o \
    lpm_init.o ls_forcing.o netcdf_interface.o plant_canopy_model.o \
    radiation_model.o random_function.o random_generator_parallel.o \
@@ -411,5 +411,5 @@
 init_slope.o: modules.o mod_kinds.o
 interaction_droplets_ptq.o: modules.o mod_kinds.o
-land_surface_model.o: modules.o mod_kinds.o radiation_model.o
+land_surface_model_mod.o: modules.o mod_kinds.o radiation_model.o
 local_stop.o: modules.o mod_kinds.o pmc_interface.o
 local_tremain.o: modules.o cpulog.o mod_kinds.o
@@ -452,11 +452,11 @@
 mod_particle_attributes.o: mod_particle_attributes.f90 mod_kinds.o
 netcdf_interface.o: netcdf_interface.f90 modules.o mod_kinds.o \
-   land_surface_model.o spectrum.o
+   land_surface_model_mod.o spectrum.o
 nudging.o: modules.o cpulog.o mod_kinds.o
-package_parin.o: modules.o mod_kinds.o land_surface_model.o \
+package_parin.o: modules.o mod_kinds.o \
    plant_canopy_model.o radiation_model.o spectrum.o
 palm.o: modules.o cpulog.o ls_forcing.o mod_kinds.o nudging.o\
 	pmc_interface.o surface_layer_fluxes.o
-parin.o: modules.o cpulog.o mod_kinds.o netcdf_interface.o \
+parin.o: modules.o cpulog.o land_surface_model_mod.o mod_kinds.o netcdf_interface.o \
    pmc_interface.o progress_bar.o
 plant_canopy_model.o: modules.o mod_kinds.o
@@ -487,5 +487,5 @@
 random_gauss.o: mod_kinds.o random_function.o random_generator_parallel.o
 random_generator_parallel.o: mod_kinds.o
-read_3d_binary.o: modules.o cpulog.o mod_kinds.o land_surface_model.o\
+read_3d_binary.o: modules.o cpulog.o mod_kinds.o land_surface_model_mod.o\
                   radiation_model.o random_function.o\
                   random_generator_parallel.o
@@ -497,13 +497,13 @@
 spectrum.o: spectrum.f90 modules.o mod_kinds.o cpulog.o fft_xy.o
 subsidence.o: modules.o mod_kinds.o
-sum_up_3d_data.o: modules.o cpulog.o mod_kinds.o land_surface_model.o\
+sum_up_3d_data.o: modules.o cpulog.o mod_kinds.o land_surface_model_mod.o\
                   radiation_model.o 
 surface_coupler.o: modules.o cpulog.o mod_kinds.o
-surface_layer_fluxes.o: modules.o mod_kinds.o land_surface_model.o
-swap_timelevel.o: modules.o cpulog.o mod_kinds.o land_surface_model.o\
+surface_layer_fluxes.o: modules.o mod_kinds.o land_surface_model_mod.o
+swap_timelevel.o: modules.o cpulog.o mod_kinds.o land_surface_model_mod.o\
    pmc_interface.o
 temperton_fft.o: modules.o mod_kinds.o
 time_integration.o: modules.o advec_ws.o buoyancy.o calc_mean_profile.o \
-	cpulog.o interaction_droplets_ptq.o land_surface_model.o \
+	cpulog.o interaction_droplets_ptq.o land_surface_model_mod.o \
 	ls_forcing.o mod_kinds.o nudging.o pmc_interface.o production_e.o \
 	prognostic_equations.o progress_bar.o radiation_model.o \
@@ -531,5 +531,5 @@
 user_init_3d_model.o: modules.o mod_kinds.o user_module.o
 user_init_grid.o: modules.o mod_kinds.o user_module.o
-user_init_land_surface.o: modules.o mod_kinds.o user_module.o land_surface_model.o
+user_init_land_surface.o: modules.o mod_kinds.o user_module.o land_surface_model_mod.o
 user_init_plant_canopy.o: modules.o mod_kinds.o user_module.o plant_canopy_model.o
 user_init_radiation.o: modules.o mod_kinds.o user_module.o radiation_model.o
@@ -544,5 +544,5 @@
 user_statistics.o: modules.o mod_kinds.o netcdf_interface.o user_module.o
 wall_fluxes.o: modules.o mod_kinds.o
-write_3d_binary.o: modules.o cpulog.o mod_kinds.o land_surface_model.o\
+write_3d_binary.o: modules.o cpulog.o mod_kinds.o land_surface_model_mod.o\
                    radiation_model.o random_function.o\
                    random_generator_parallel.o
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1816)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1817)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Moved checks for land_surface model to the respective module
 ! 
 ! Former revisions:
@@ -330,5 +330,7 @@
     USE grid_variables
     USE indices
-    USE land_surface_model_mod
+    USE land_surface_model_mod,                                                &
+        ONLY: land_surface, lsm_check_data_output, lsm_check_data_output_pr,   &
+              lsm_check_parameters, nzs, zs
     USE kinds
     USE model_1d
@@ -1035,179 +1037,8 @@
     ENDIF
 
-
-    IF ( land_surface )  THEN
- 
-!
-!--    Dirichlet boundary conditions are required as the surface fluxes are
-!--    calculated from the temperature/humidity gradients in the land surface
-!--    model
-       IF ( bc_pt_b == 'neumann'  .OR.  bc_q_b == 'neumann' )  THEN
-          message_string = 'lsm requires setting of'//                         &
-                           'bc_pt_b = "dirichlet" and '//                      &
-                           'bc_q_b  = "dirichlet"'
-          CALL message( 'check_parameters', 'PA0399', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF (  .NOT.  constant_flux_layer )  THEN
-          message_string = 'lsm requires '//                                   &
-                           'constant_flux_layer = .T.'
-          CALL message( 'check_parameters', 'PA0400', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( topography /= 'flat' )  THEN
-          message_string = 'lsm cannot be used ' //                            & 
-                           'in combination with  topography /= "flat"'
-          CALL message( 'check_parameters', 'PA0415', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( ( veg_type == 14  .OR.  veg_type == 15 ) .AND.                       &
-              most_method == 'lookup' )  THEN
-           WRITE( message_string, * ) 'veg_type = ', veg_type, ' is not ',     &
-                                      'allowed in combination with ',          &
-                                      'most_method = ', most_method
-          CALL message( 'check_parameters', 'PA0417', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( veg_type == 0 )  THEN
-          IF ( SUM( root_fraction ) /= 1.0_wp )  THEN
-             message_string = 'veg_type = 0 (user_defined)'//                  &
-                              'requires setting of root_fraction(0:3)'//       &
-                              '/= 9999999.9 and SUM(root_fraction) = 1'
-             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-          ENDIF
- 
-          IF ( min_canopy_resistance == 9999999.9_wp )  THEN
-             message_string = 'veg_type = 0 (user defined)'//                  &
-                              'requires setting of min_canopy_resistance'//    &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( leaf_area_index == 9999999.9_wp )  THEN
-             message_string = 'veg_type = 0 (user_defined)'//                  &
-                              'requires setting of leaf_area_index'//          &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( vegetation_coverage == 9999999.9_wp )  THEN
-             message_string = 'veg_type = 0 (user_defined)'//                  &
-                              'requires setting of vegetation_coverage'//      &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( canopy_resistance_coefficient == 9999999.9_wp)  THEN
-             message_string = 'veg_type = 0 (user_defined)'//                  &
-                              'requires setting of'//                          &
-                              'canopy_resistance_coefficient /= 9999999.9'
-             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( lambda_surface_stable == 9999999.9_wp )  THEN
-             message_string = 'veg_type = 0 (user_defined)'//                  &
-                              'requires setting of lambda_surface_stable'//    &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( lambda_surface_unstable == 9999999.9_wp )  THEN
-             message_string = 'veg_type = 0 (user_defined)'//                  &
-                              'requires setting of lambda_surface_unstable'//  &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( f_shortwave_incoming == 9999999.9_wp )  THEN
-             message_string = 'veg_type = 0 (user_defined)'//                  &
-                              'requires setting of f_shortwave_incoming'//     &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( z0_eb == 9999999.9_wp )  THEN
-             message_string = 'veg_type = 0 (user_defined)'//                  &
-                              'requires setting of z0_eb'//                   &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( z0h_eb == 9999999.9_wp )  THEN
-             message_string = 'veg_type = 0 (user_defined)'//                  &
-                              'requires setting of z0h_eb'//                  &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-          ENDIF
-
-
-       ENDIF
-
-       IF ( soil_type == 0 )  THEN
-
-          IF ( alpha_vangenuchten == 9999999.9_wp )  THEN
-             message_string = 'soil_type = 0 (user_defined)'//                 &
-                              'requires setting of alpha_vangenuchten'//       &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0403', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( l_vangenuchten == 9999999.9_wp )  THEN
-             message_string = 'soil_type = 0 (user_defined)'//                 &
-                              'requires setting of l_vangenuchten'//           &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0403', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( n_vangenuchten == 9999999.9_wp )  THEN
-             message_string = 'soil_type = 0 (user_defined)'//                 &
-                              'requires setting of n_vangenuchten'//           &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0403', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( hydraulic_conductivity == 9999999.9_wp )  THEN
-             message_string = 'soil_type = 0 (user_defined)'//                 &
-                              'requires setting of hydraulic_conductivity'//   &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0403', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( saturation_moisture == 9999999.9_wp )  THEN
-             message_string = 'soil_type = 0 (user_defined)'//                 &
-                              'requires setting of saturation_moisture'//      &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0403', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( field_capacity == 9999999.9_wp )  THEN
-             message_string = 'soil_type = 0 (user_defined)'//                 &
-                              'requires setting of field_capacity'//           &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0403', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( wilting_point == 9999999.9_wp )  THEN
-             message_string = 'soil_type = 0 (user_defined)'//                 &
-                              'requires setting of wilting_point'//            &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0403', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( residual_moisture == 9999999.9_wp )  THEN
-             message_string = 'soil_type = 0 (user_defined)'//                 &
-                              'requires setting of residual_moisture'//        &
-                              '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0403', 1, 2, 0, 6, 0 )
-          ENDIF
-
-       ENDIF
-
-       IF (  .NOT.  radiation )  THEN
-          message_string = 'lsm requires '//                                   &
-                           'radiation = .T.'
-          CALL message( 'check_parameters', 'PA0400', 1, 2, 0, 6, 0 )
-       ENDIF
-
-    END IF 
+!
+!-- When land surface model is used, peform addtional checks
+    IF ( land_surface )  CALL lsm_check_parameters
+
 
     IF ( radiation )  THEN
@@ -3144,38 +2975,4 @@
              ENDIF
 
-          CASE ( 't_soil', '#t_soil' )
-             IF (  .NOT.  land_surface )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for land_surface = .FALSE.'
-                CALL message( 'check_parameters', 'PA0402', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 89
-                dopr_unit(i)  = 'K'
-                hom(0:nzs-1,2,89,:)  = SPREAD( - zs, 2, statistic_regions+1 )
-                IF ( data_output_pr(i)(1:1) == '#' )  THEN
-                   dopr_initial_index(i) = 90
-                   hom(0:nzs-1,2,90,:)   = SPREAD( - zs, 2, statistic_regions+1 )
-                   data_output_pr(i)     = data_output_pr(i)(2:)
-                ENDIF
-             ENDIF
-
-          CASE ( 'm_soil', '#m_soil' )
-             IF (  .NOT.  land_surface )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for land_surface = .FALSE.'
-                CALL message( 'check_parameters', 'PA0402', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 91
-                dopr_unit(i)  = 'm3/m3'
-                hom(0:nzs-1,2,91,:)  = SPREAD( - zs, 2, statistic_regions+1 )
-                IF ( data_output_pr(i)(1:1) == '#' )  THEN
-                   dopr_initial_index(i) = 92
-                   hom(0:nzs-1,2,92,:)   = SPREAD( - zs, 2, statistic_regions+1 )
-                   data_output_pr(i)     = data_output_pr(i)(2:)
-                ENDIF
-             ENDIF
-
           CASE ( 'rad_net' )
              IF ( (  .NOT.  radiation )  .OR.  radiation_scheme == 'constant' )&
@@ -3306,5 +3103,9 @@
           CASE DEFAULT
 
-             CALL user_check_data_output_pr( data_output_pr(i), i, unit )
+             CALL lsm_check_data_output_pr( data_output_pr(i), i, unit, dopr_unit(i) )
+
+             IF ( unit == 'illegal' )  THEN
+                CALL user_check_data_output_pr( data_output_pr(i), i, unit )
+             ENDIF
 
              IF ( unit == 'illegal' )  THEN
@@ -3394,12 +3195,4 @@
              unit = 'K'
 
-          CASE ( 'm_soil' )
-             IF (  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                         'land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             unit = 'm3/m3'
-
           CASE ( 'nr' )
              IF (  .NOT.  cloud_physics )  THEN
@@ -3536,19 +3329,15 @@
              unit = 'psu'
 
-          CASE ( 't_soil' )
-             IF (  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                         'land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             unit = 'K'
-
-
-          CASE ( 'c_liq*', 'c_soil*', 'c_veg*', 'ghf_eb*', 'lai*', 'lwp*',     &
-                 'm_liq_eb*', 'ol*', 'pra*', 'prr*', 'qsws*', 'qsws_eb*',      &
-                 'qsws_liq_eb*', 'qsws_soil_eb*', 'qsws_veg_eb*', 'rad_net*',  &
+          CASE ( 'p', 'pt', 'u', 'v', 'w' )
+             IF ( TRIM( var ) == 'p'  )  unit = 'Pa'
+             IF ( TRIM( var ) == 'pt' )  unit = 'K'
+             IF ( TRIM( var ) == 'u'  )  unit = 'm/s'
+             IF ( TRIM( var ) == 'v'  )  unit = 'm/s'
+             IF ( TRIM( var ) == 'w'  )  unit = 'm/s'
+             CONTINUE
+
+          CASE ( 'lai*', 'lwp*', 'ol*', 'pra*', 'prr*', 'qsws*', 'rad_net*',   &
                  'rrtm_aldif*', 'rrtm_aldir*', 'rrtm_asdif*', 'rrtm_asdir*',   &
-                 'r_a*', 'r_s*', 'shf*', 'shf_eb*', 't*', 'u*', 'z0*', 'z0h*', &
-                 'z0q*' )
+                 'shf*', 't*', 'u*', 'z0*', 'z0h*', 'z0q*' )
              IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
                 message_string = 'illegal value for data_output: "' //         &
@@ -3569,25 +3358,4 @@
                 ENDIF
              ENDIF
-
-             IF ( TRIM( var ) == 'c_liq*'  .AND.  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'c_soil*'  .AND.  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'c_veg*'  .AND.  .NOT. land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'ghf_eb*'  .AND.  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
              IF ( TRIM( var ) == 'lai*'  .AND.  .NOT.  land_surface )  THEN
                 message_string = 'output of "' // TRIM( var ) // '" requi' //  &
@@ -3600,9 +3368,4 @@
                 CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
              ENDIF
-             IF ( TRIM( var ) == 'm_liq_eb*'  .AND.  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
              IF ( TRIM( var ) == 'pra*'  .AND.  .NOT. precipitation )  THEN
                 message_string = 'output of "' // TRIM( var ) // '" requi' //  &
@@ -3625,55 +3388,11 @@
                 CALL message( 'check_parameters', 'PA0322', 1, 2, 0, 6, 0 )
              ENDIF
-             IF ( TRIM( var ) == 'qsws_eb*'  .AND.  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'qsws_liq_eb*'  .AND.  .NOT. land_surface )   &
-             THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'qsws_soil_eb*'  .AND.  .NOT.  land_surface ) &
-             THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'qsws_veg_eb*'  .AND.  .NOT. land_surface )   &
-             THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'r_a*'  .AND.  .NOT.  land_surface ) &
-             THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'r_s*'  .AND.  .NOT.  land_surface ) &
-             THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-
-             IF ( TRIM( var ) == 'c_liq*' )  unit = 'none'
-             IF ( TRIM( var ) == 'c_soil*')  unit = 'none'
-             IF ( TRIM( var ) == 'c_veg*' )  unit = 'none'
-             IF ( TRIM( var ) == 'ghf_eb*')  unit = 'W/m2'
+
              IF ( TRIM( var ) == 'lai*'   )  unit = 'none'
              IF ( TRIM( var ) == 'lwp*'   )  unit = 'kg/m2'
-             IF ( TRIM( var ) == 'm_liq_eb*'     )  unit = 'm'
              IF ( TRIM( var ) == 'ol*'   )   unit = 'm'
              IF ( TRIM( var ) == 'pra*'   )  unit = 'mm'
              IF ( TRIM( var ) == 'prr*'   )  unit = 'mm/s'
              IF ( TRIM( var ) == 'qsws*'  )  unit = 'kgm/kgs'
-             IF ( TRIM( var ) == 'qsws_eb*'      ) unit = 'W/m2'
-             IF ( TRIM( var ) == 'qsws_liq_eb*'  ) unit = 'W/m2'
-             IF ( TRIM( var ) == 'qsws_soil_eb*' ) unit = 'W/m2'
-             IF ( TRIM( var ) == 'qsws_veg_eb*'  ) unit = 'W/m2'
              IF ( TRIM( var ) == 'rad_net*'      ) unit = 'W/m2'   
              IF ( TRIM( var ) == 'rrtm_aldif*'   ) unit = ''   
@@ -3681,25 +3400,17 @@
              IF ( TRIM( var ) == 'rrtm_asdif*'   ) unit = '' 
              IF ( TRIM( var ) == 'rrtm_asdir*'   ) unit = '' 
-             IF ( TRIM( var ) == 'r_a*')     unit = 's/m'     
-             IF ( TRIM( var ) == 'r_s*')     unit = 's/m' 
              IF ( TRIM( var ) == 'shf*'   )  unit = 'K*m/s'
-             IF ( TRIM( var ) == 'shf_eb*')  unit = 'W/m2'
              IF ( TRIM( var ) == 't*'     )  unit = 'K'
              IF ( TRIM( var ) == 'u*'     )  unit = 'm/s'
              IF ( TRIM( var ) == 'z0*'    )  unit = 'm'
-             IF ( TRIM( var ) == 'z0h*'   )  unit = 'm'
-
-
-          CASE ( 'p', 'pt', 'u', 'v', 'w' )
-             IF ( TRIM( var ) == 'p'  )  unit = 'Pa'
-             IF ( TRIM( var ) == 'pt' )  unit = 'K'
-             IF ( TRIM( var ) == 'u'  )  unit = 'm/s'
-             IF ( TRIM( var ) == 'v'  )  unit = 'm/s'
-             IF ( TRIM( var ) == 'w'  )  unit = 'm/s'
-             CONTINUE
-
+             IF ( TRIM( var ) == 'z0h*'   )  unit = 'm' 
+             
           CASE DEFAULT
 
-             CALL user_check_data_output( var, unit )
+             CALL lsm_check_data_output ( var, unit, i, ilen, k )
+             
+             IF ( unit == 'illegal' )  THEN
+                CALL user_check_data_output( var, unit )
+             ENDIF
 
              IF ( unit == 'illegal' )  THEN
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 1816)
+++ palm/trunk/SOURCE/header.f90	(revision 1817)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-!
+! Moved land_surface_model header output to the respective module.
 !
 ! Former revisions:
@@ -258,9 +258,7 @@
         
     USE kinds
-   
+ 
     USE land_surface_model_mod,                                                &
-        ONLY:  conserve_water_content, land_surface, nzb_soil,                 &
-               nzt_soil, root_fraction, soil_moisture, soil_temperature,       &
-               soil_type, soil_type_name, veg_type, veg_type_name, zs
+        ONLY: land_surface, lsm_header
  
     USE model_1d,                                                              &
@@ -969,49 +967,5 @@
     ENDIF
 
-
-    IF ( land_surface )  THEN
-
-       temperatures = ''
-       gradients    = '' ! use for humidity here
-       coordinates  = '' ! use for height
-       roots        = '' ! use for root fraction
-       slices       = '' ! use for index
-
-       i = 1
-       DO i = nzb_soil, nzt_soil
-          WRITE (coor_chr,'(F10.2,7X)') soil_temperature(i)
-          temperatures = TRIM( temperatures ) // ' ' // TRIM( coor_chr )
-
-          WRITE (coor_chr,'(F10.2,7X)') soil_moisture(i)
-          gradients = TRIM( gradients ) // ' ' // TRIM( coor_chr )
-
-          WRITE (coor_chr,'(F10.2,7X)')  - zs(i)
-          coordinates = TRIM( coordinates ) // ' '  // TRIM( coor_chr )
-
-          WRITE (coor_chr,'(F10.2,7X)')  root_fraction(i)
-          roots = TRIM( roots ) // ' '  // TRIM( coor_chr )
-
-          WRITE (coor_chr,'(I10,7X)')  i
-          slices = TRIM( slices ) // ' '  // TRIM( coor_chr )
-
-
-       ENDDO
-
-!
-!--    Write land surface model header
-       WRITE( io, 419 )
-       IF ( conserve_water_content )  THEN
-          WRITE( io, 440 )
-       ELSE
-          WRITE( io, 441 )
-       ENDIF
-
-       WRITE( io, 438 ) TRIM( veg_type_name(veg_type) ),                       &
-                        TRIM (soil_type_name(soil_type) )
-       WRITE( io, 439 ) TRIM( coordinates ), TRIM( temperatures ),             &
-                        TRIM( gradients ), TRIM( roots ), TRIM( slices )
-
-
-    ENDIF
+    IF ( land_surface )  CALL lsm_header ( io )
 
     IF ( radiation )  THEN
@@ -2308,6 +2262,4 @@
 418 FORMAT (/'    Day of the year at model start :   day_init      =     ',I3 &
             /'    UTC time at model start        :   time_utc_init = ',F7.1' s')
-419 FORMAT (//' Land surface model information:'/ &
-              ' ------------------------------'/)
 420 FORMAT (/'    Characteristic levels of the initial temperature profile:'// &
             '       Height:        ',A,'  m'/ &
@@ -2368,14 +2320,4 @@
                        '[0,1000] cm**2/s**3')
 437 FORMAT ('    Droplet collision is switched off')
-438 FORMAT (' --> Land surface type  : ',A,/ &
-            ' --> Soil porosity type : ',A)
-439 FORMAT (/'    Initial soil temperature and moisture profile:'// &
-            '       Height:        ',A,'  m'/ &
-            '       Temperature:   ',A,'  K'/ &
-            '       Moisture:      ',A,'  m**3/m**3'/ &
-            '       Root fraction: ',A,'  '/ &
-            '       Gridpoint:     ',A)
-440 FORMAT (' --> Soil bottom is closed (water content is conserved, default)')
-441 FORMAT (' --> Soil bottom is open (water content is not conserved)')
 444 FORMAT (//' Radiation model information:'/                                 &
               ' ----------------------------'/)
